package com.gic.haoban.manage.web.handle;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.gic.commons.util.DataApiUtils;
import com.gic.enterprise.api.dto.security.DownloadReportDTO;
import com.gic.haoban.manage.web.utils.data.StoreAuthUtils;
import com.gic.haoban.manage.web.vo.chat.GroupChatClerkVO;
import com.gic.haoban.manage.web.vo.chat.SingleChatDetailVO;
import com.gic.haoban.manage.web.vo.wechatwork.WechatWorkLostDetailVO;
import com.gic.web.common.download.DownloadHandlerAbstract;
import com.gic.web.common.download.context.Context;
import org.apache.commons.collections.CollectionUtils;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Collections;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

/**
 * @author shangfeng
 * @date 2024-06-21 11:34:23
 */
@Component
public class SingleChatDetailsHandle extends DownloadHandlerAbstract<SingleChatDetailVO> {

    private static final Logger LOGGER = LogManager.getLogger(SingleChatDetailsHandle.class);

    @Autowired
    private StoreAuthUtils storeAuthUtils;

    @Override
    public List<SingleChatDetailVO> getData(Context context, String searchDataParams, Integer currentPage) {
        JSONObject jsonObject = JSON.parseObject(searchDataParams);
        jsonObject.put("pageNum", currentPage);
        jsonObject.put("pageSize", getPageSize());
        Map<String, Object> res = DataApiUtils.http(jsonObject.toJSONString(), "data_mbr_scale_haoban_qw_chat_detail");
        List<JSONObject> list = DataApiUtils.getPageList(res);
        if (CollectionUtils.isNotEmpty(list)) {
            List<SingleChatDetailVO> result = JSONObject.parseArray(JSON.toJSONString(list), SingleChatDetailVO.class);
            return result;
        }
        return Collections.EMPTY_LIST;
    }

    @Override
    public List<String> getColumnNames() {
        return Collections.EMPTY_LIST;
    }

    @Override
    public List<String> getColumnNames(Context context) {
        DownloadReportDTO downloadReportDTO = context.getDownloadReportDTO();
        String searchDataParams = downloadReportDTO.getSearchDataParams();
        JSONObject jsonObject = JSONObject.parseObject(searchDataParams);
        List<String> list = (List<String>) jsonObject.get("indexList");
        return list;
    }

    @Override
    public LinkedHashMap<String, List<String>> doubleColumnNames() {
        return null;
    }

    @Override
    public List<String> getColumns() {
        return Collections.EMPTY_LIST;
    }

    @Override
    public List<String> getColumns(Context context) {
        DownloadReportDTO downloadReportDTO = context.getDownloadReportDTO();
        String searchDataParams = downloadReportDTO.getSearchDataParams();
        JSONObject jsonObject = JSONObject.parseObject(searchDataParams);
        List<String> list = (List<String>) jsonObject.get("fieldList");
        return list;
    }
}
